module EcconnectRails
  module ControllerActions
    def new
      @ecconnect_payment = resource_class.new
      respond_to do |format|
        format.html do 
          render 'new'
        end
        format.json{ render json: @ecconnect_payment.ecconnect_json }
      end
    end

    def create
      @ecconnect_payment = resource_class.new params[:ecconnect_payment]
      if @ecconnect_payment.save
        respond_to do |format|
          format.html{ redirect_to ecconnect_payment_path(@ecconnect_payment.to_param) }
          format.json{ render json: @ecconnect_payment.ecconnect_json }
        end
      else
        respond_to do |format|
          format.html{ render 'new' }
          format.json{ render json: @ecconnect_payment.ecconnect_json }
        end
      end
    end

    def show
      @ecconnect_payment = resource_class.find params[:id]
      respond_to do |format|
        format.html do 
          render 'show'
        end
        format.json{ render json: @ecconnect_payment.ecconnect_json }
      end
    end

    def check
      @ecconnect_payment = resource_class.find params[:id]
      respond_to do |format|
        format.html do 
          render 'check'
        end
        format.json{ render json: @ecconnect_payment.ecconnect_json }
      end
    end

    def failure
      @ecconnect_payment = resource_class.where(order_id: params[:OrderID]).limit(1).first
      @ecconnect_payment.update_by params
      if @ecconnect_payment.check_signature
        failure_right_signature @ecconnect_payment
        failure_respond @ecconnect_payment
      else
        failure_wrong_signature @ecconnect_payment
        wrong_signature_respond @ecconnect_payment
      end
    end

    def success
      @ecconnect_payment = resource_class.where(order_id: params[:OrderID]).limit(1).first
      @ecconnect_payment.update_by params
      if @ecconnect_payment.check_signature
        if @ecconnect_payment.tran_code == '000'
          success_right_signature @ecconnect_payment
          success_respond @ecconnect_payment
        else
          failure_right_signature @ecconnect_payment
          failure_respond @ecconnect_payment
        end
      else
        success_wrong_signature @ecconnect_payment
        wrong_signature_respond @ecconnect_payment
      end
    end

    def notify
      @ecconnect_payment = resource_class.where(order_id: params[:OrderID]).limit(1).first
      @ecconnect_payment.update_by params
      if @ecconnect_payment.check_signature
        if @ecconnect_payment.tran_code == '000'
          @action = 'approve'
          @forward_url = forward_url_success
          notify_right_signature_and_code @ecconnect_payment
          notify_respond @ecconnect_payment
        else
          @action = 'reverse'
          @reason = I18n.t "ecconnect_rails.codes.code_503"
          @forward_url = forward_url_failure
          notify_right_signature @ecconnect_payment
          notify_respond @ecconnect_payment
        end
      else
        @action = 'reverse'
        @reason = I18n.t "ecconnect_rails.codes.code_405"
        @forward_url = forward_url_failure
        notify_wrong_signature @ecconnect_payment
        notify_respond @ecconnect_payment
      end
    end

  private

    def forward_url_success
    end

    def forward_url_failure
    end

    def notify_respond ecconnect_payment
      respond_to do |format|
        format.html do 
          render 'notify', layout: nil
        end
      end
    end

    def success_respond ecconnect_payment
      respond_to do |format|
        format.html do
          flash[:notice] = I18n.t "ecconnect_rails.success"  
          render 'success'
        end
        format.json{ render json: @ecconnect_payment.ecconnect_json }
      end
    end

    def failure_respond ecconnect_payment
      respond_to do |format|
        format.html do
          flash[:error] = I18n.t "ecconnect_rails.codes.code_#{@ecconnect_payment.tran_code}" 
          render 'failure'
        end
        format.json{ render json: @ecconnect_payment.ecconnect_json }
      end
    end

    def wrong_signature_respond ecconnect_payment
      respond_to do |format|
        format.html do
          flash[:error] = I18n.t "ecconnect_rails.wrong_signature" 
          render 'failure'
        end
        format.json{ render json: @ecconnect_payment.ecconnect_json }
      end
    end

    def success_right_signature ecconnect_payment
    end

    def success_wrong_signature ecconnect_payment
    end

    def failure_right_signature ecconnect_payment
    end

    def failure_wrong_signature ecconnect_payment
    end

    def notify_right_signature ecconnect_payment
    end

    def notify_right_signature_and_code ecconnect_payment
    end

    def notify_wrong_signature ecconnect_payment
    end
  end
end